'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _Protected = require('../Protected');

var _Protected2 = _interopRequireDefault(_Protected);

var TreeNode = _react2['default'].createClass({
  displayName: 'TreeNode',

  propTypes: {
    data: _react2['default'].PropTypes.object.isRequired
  },

  concealedKeys: ['password'],

  render: function render() {
    return _react2['default'].createElement(
      'ul',
      null,
      this.props.data.map(this.renderRow, this)
    );
  },

  renderRow: function renderRow(value, key) {
    return _react2['default'].createElement(
      'li',
      null,
      _immutable2['default'].Iterable.isIterable(value) ? this.renderNode(value, key) : this.renderLeaf(value, key)
    );
  },

  renderNode: function renderNode(value, key) {
    return _react2['default'].createElement(
      'span',
      null,
      _react2['default'].createElement(
        'strong',
        null,
        key
      ),
      _react2['default'].createElement(TreeNode, { data: value })
    );
  },

  renderValue: function renderValue(value, key) {
    if (this.concealedKeys.indexOf(key) >= 0) {
      return _react2['default'].createElement(
        _Protected2['default'],
        null,
        String(value)
      );
    } else {
      return String(value);
    }
  },

  renderLeaf: function renderLeaf(value, key) {
    return _react2['default'].createElement(
      'span',
      null,
      _react2['default'].createElement(
        'strong',
        null,
        key
      ),
      ': ',
      this.renderValue(value, key)
    );
  }
});

exports['default'] = TreeNode;
module.exports = exports['default'];